const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const chat_events = sequelize.define(
    'chat_events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

event_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"typing_start",


"typing_stop",


"presence_online",


"presence_offline"

        ],

      },

event_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  chat_events.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.chat_events.belongsTo(db.matches, {
      as: 'match',
      foreignKey: {
        name: 'matchId',
      },
      constraints: false,
    });

    db.chat_events.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.chat_events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.chat_events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return chat_events;
};


